/*-
 * Copyright (c) 2003 the grugq
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the grugq
 * 4. The name of the author may be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <dlfcn.h>
#include <sys/mman.h>
#include <sys/stat.h>

static void *
map_up(const char *fname)
{
	struct stat	st;
	void	* buf;
	int	  fd;


	if ((fd = open(fname, O_RDONLY)) == -1) {
		return NULL;
	}

	if (fstat(fd, &st)) {
		close(fd);
		return NULL;
	}

	buf = mmap(NULL, st.st_size, PROT_READ, MAP_PRIVATE, fd, 0);

	return (buf == MAP_FAILED ? NULL : buf);
}

int
main(int argc, char **argv)
{
	char	* fname;
	void	* buf, * handle;
	void	 (*ul_exec)(void *, int, char**);


	fname = argc > 1 ? argv[1] : "./a.out";

	if (argc > 1) {
		argv++;
		argc--;
	} else {
		argv[0] = fname;
		argc = 1;
	}

	if ((buf = map_up(fname)) == NULL) {
		perror("map_up() ");
		return (2);
	}

	if ((handle = dlopen("./src/libulexec.so", RTLD_LAZY|RTLD_GLOBAL)) == NULL){
		fprintf(stderr, "shit: %s\n", dlerror());
		return (2);
	}

	if ((ul_exec = (void (*)()) dlsym(handle, "ul_exec")) == NULL) {
		fprintf(stderr, "fuck: %s\n", dlerror());
		return (2);
	}

	ul_exec(buf, argc, argv);

	perror("critical flailure!");
	return (3);
}
